Attribute VB_Name = "Module1"
Option Explicit

Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Declare Function SetCapture Lib "user32" (ByVal hwnd As Long) As Long
Declare Function ReleaseCapture Lib "user32" () As Long
Public Const WM_SYSCOMMAND = &H112
Public Const SC_MOVE = &HF010&

Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Const HWND_TOPMOST = -1
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOSIZE = &H1

Declare Function CreateEllipticRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Declare Function CreatePolygonRgn Lib "gdi32" (lpPoint As POINTAPI, ByVal nCount As Long, ByVal nPolyFillMode As Long) As Long
Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Type POINTAPI
        X As Long
        Y As Long
End Type
Public Const RGN_OR = 2
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function SetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Long) As Long

'_ꗗ
Public Const PointSize = 4
Public PX(2) As Long, PY(2) As Long
Public PointID As Long
Public hRgn As Long

Function GetDegree(ByVal X As Single, ByVal Y As Single) As Single
Dim temp!

If X ^ 2 + Y ^ 2 < 0.1 Then Exit Function

If Abs(X) > 0.1 Then
  
  temp = Atn(-Y / X)
  GetDegree = temp * 180 / 3.1415926
  If X < 0 Then GetDegree = GetDegree + 180
  If GetDegree < 0 Then GetDegree = GetDegree + 360

Else
  If Y < 0 Then GetDegree = 90
  If Y > 0 Then GetDegree = 270
End If


End Function

Sub RefreshWindow()
Dim p3 As Boolean
Dim s$
Dim r1&, r2&, p(4) As POINTAPI
Dim f!
Dim i&, j&

p3 = IndWin.Option1(1).Value

'[W̐
r1 = CreateEllipticRgn(PX(0) - PointSize, PY(0) - PointSize, PX(0) + PointSize, PY(0) + PointSize)
r2 = CreateEllipticRgn(PX(1) - PointSize, PY(1) - PointSize, PX(1) + PointSize, PY(1) + PointSize)
Call CombineRgn(r1, r1, r2, RGN_OR)
Call DeleteObject(r2)

If p3 Then
  r2 = CreateEllipticRgn(PX(2) - PointSize, PY(2) - PointSize, PX(2) + PointSize, PY(2) + PointSize)
  Call CombineRgn(r1, r1, r2, RGN_OR)
  Call DeleteObject(r2)
End If

'p0p1Ԓ
If PX(0) <> PX(1) Or PY(0) <> PY(1) Then
  f = Sqr((PX(1) - PX(0)) ^ 2 + (PY(1) - PY(0)) ^ 2)
  p(0).X = PX(0) + (PY(1) - PY(0)) / f
  p(1).X = PX(1) + (PY(1) - PY(0)) / f
  p(2).X = PX(1) - (PY(1) - PY(0)) / f
  p(3).X = PX(0) - (PY(1) - PY(0)) / f
  p(0).Y = PY(0) + (PX(1) - PX(0)) / f
  p(1).Y = PY(1) + (PX(1) - PX(0)) / f
  p(2).Y = PY(1) - (PY(1) - PY(0)) / f
  p(3).Y = PY(0) - (PY(1) - PY(0)) / f
  r2 = CreatePolygonRgn(p(0), 4, 1)
Call CombineRgn(r1, r1, r2, RGN_OR)
Call DeleteObject(r2)
End If

If p3 Then
  If PX(2) <> PX(1) Or PY(2) <> PY(1) Then
    f = Sqr((PX(1) - PX(2)) ^ 2 + (PY(1) - PY(2)) ^ 2)
    p(0).X = PX(2) + (PY(1) - PY(2)) / f
    p(1).X = PX(1) + (PY(1) - PY(2)) / f
    p(2).X = PX(1) - (PY(1) - PY(2)) / f
    p(3).X = PX(2) - (PY(1) - PY(2)) / f
    p(0).Y = PY(2) + (PX(1) - PX(2)) / f
    p(1).Y = PY(1) + (PX(1) - PX(2)) / f
    p(2).Y = PY(1) - (PY(1) - PY(2)) / f
    p(3).Y = PY(2) - (PY(1) - PY(2)) / f
    r2 = CreatePolygonRgn(p(0), 4, 1)
  Call CombineRgn(r1, r1, r2, RGN_OR)
  Call DeleteObject(r2)
  End If
End If
  

Call SetWindowRgn(PointWin.hwnd, r1, 1)
Call PointWin.Refresh
Call DeleteObject(hRgn)
hRgn = r1

'摜̕`

PointWin.Cls
PointWin.FillColor = vbRed
PointWin.Circle (PX(0), PY(0)), PointSize, vbRed
PointWin.PSet (PX(0), PY(0)), vbBlack
PointWin.FillColor = vbGreen
PointWin.Circle (PX(1), PY(1)), PointSize, vbGreen
PointWin.PSet (PX(1), PY(1)), vbBlack

If p3 Then
  PointWin.FillColor = vbBlue
  PointWin.Circle (PX(2), PY(2)), PointSize, vbBlue
  PointWin.PSet (PX(2), PY(2)), vbBlack
  PointWin.Line (PX(1), PY(1))-(PX(2), PY(2))
End If

PointWin.Line (PX(0), PY(0))-(PX(1), PY(1))


'eLXg̐
s = "R=(" + CStr(PX(0)) + "," + CStr(PY(0)) + ")"
s = s + " , G=(" + CStr(PX(1)) + "," + CStr(PY(1)) + ")" + vbCrLf
If p3 Then
  'x
  If p3 Then s = s + "B=(" + CStr(PX(2)) + "," + CStr(PY(2)) + ")" + vbCrLf
  s = s + "ARG(R)=" + CStr(i)
  s = s + " , ARG(B)=" + CStr(Int(GetDegree(PX(2) - PX(1), PY(2) - PY(1)))) + vbCrLf
  i = Int(GetDegree(PX(2) - PX(1), PY(2) - PY(1)) - GetDegree(PX(0) - PX(1), PY(0) - PY(1)))
  If i < 0 Then j = i + 360
  If i > 0 Then j = i - 360
  s = s + "ARG=" + CStr(i) + " (" + CStr(j) + ")" + vbCrLf
  
Else
  s = s + "W=" + CStr(PX(1) - PX(0)) + " , H=" + CStr(PY(1) - PY(0))
  s = s + " , L=" + CStr(Int(Sqr((PX(1) - PX(0)) ^ 2 + (PY(1) - PY(0)) ^ 2)))
End If

IndWin.Label1 = s
IndWin.Refresh

End Sub
